<template>
    <v-select
        v-model="localValue"
        item-text="name"
        item-value="id"
        :items="localItems"
        :loading="loading"
        :placeholder="placeholder"
        :error-messages="errors"
        hide-selected
        chips
        deletable-chips
        outlined
        :menu-props="{ bottom: true, offsetY: true }"
    >
    </v-select>
</template>

<script>
    export default {
        name: "VProductTypeSelect",
        props: {
            value: {
                validator: val => typeof val === 'number' || val === null
            },
            errors: [String, Array],
            placeholder: {
                type: String,
                default: ''
            },
            hideDetails: {
                type: [Boolean, String],
                default: false
            },
            clearable: {
                type: Boolean,
                default: false
            },
            items: {
                type: Array,
                default: () => []
            }
        },

        data: () => ({
            loading: false,
            types: []
        }),

        computed: {
            localItems() {
                return !!this.items.length ? this.items : this.types
            },
            localValue: {
                get() {
                    return this.value;
                },
                set(val) {
                    this.$emit('input', val);
                }
            }
        },

        created() {
            if(this.items.length === 0) {
                this.fetchProductTypes()
                    .then(data => {
                        this.loading = false;
                        this.types = data;
                    })
                    .catch(error => {
                        console.error('Request failed.', error);
                    });
            }
        },

        methods: {
            fetchProductTypes(type = 1) {
                this.loading = true;
                this.types = [];

                return new Promise((resolve, reject) => {
                    axios.get('api/products/types?business_type_id='+type)
                        .then(({ data }) => {
                            this.types = data;
                            this.loading = false;
                            resolve(data);
                        })
                        .catch(error => {
                            reject(error);
                        })
                        .finally(() => {
                            this.loading = false;
                        })
                });
            }
        }
    }
</script>

<style scoped>

</style>
